var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a;
import logger from "../../utils/logger";
import { checkEmailInWhiteList } from "../../utils/verify";
export var ENV = {
    PROD: "prod",
    DEV: "dev",
    LOCAL: "local",
};
var TAB_DEBUG = {
    CONSOLE: "console",
    NETWORK: "network",
    SETTING: "setting",
};
var FILTER_TYPE = [
    { key: "all", title: "All", logs: [] },
    { key: "success", title: "Success", logs: [] },
    { key: "error", title: "Error", logs: [] },
];
var tracking = (_a = {},
    _a[TAB_DEBUG.CONSOLE] = logger.trackingLog,
    _a[TAB_DEBUG.NETWORK] = logger.trackingRequest,
    _a);
var TYPE_VIEW = {
    SHAKE: "shake",
    CIRCLE: "circle",
    DEFAULT: "default",
};
var SETTING_OPTIONS = [
    {
        field: "type",
        title: "Chế độ xem",
        icon: "geometry",
        activeValue: "on",
        values: {
            on: {
                value: TYPE_VIEW.CIRCLE,
                title: "Luôn hiển thị",
            },
            off: {
                value: TYPE_VIEW.SHAKE,
                title: "Lắc để bật",
            },
        },
        isFieldInConfig: false,
    },
    {
        field: "isSendToSlack",
        title: "Thông báo qua Slack",
        icon: "adjustment",
        activeValue: logger.isSendToSlack ? "on" : "off",
        values: {
            on: {
                value: true,
                title: "Bật",
            },
            off: {
                value: false,
                title: "Tắt",
            },
        },
        isFieldInConfig: true,
    },
];
Component({
    props: {
        type: TYPE_VIEW.DEFAULT,
        env: ENV.DEV,
    },
    data: {
        tab: TAB_DEBUG.CONSOLE,
        isShowLog: false,
        isShowLogBottomSheet: false,
        isShowRequestBottomSheet: false,
        search: "",
        logList: [],
        activeRequest: null,
        networkFilter: FILTER_TYPE,
        activeLog: null,
        isShow: false,
        activeFilter: FILTER_TYPE[0].key,
        settingOptions: SETTING_OPTIONS,
    },
    onInit: function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.onInput = function (event) {
                    clearTimeout(_this.timerId);
                    var search = event.detail.value;
                    _this.timerId = setTimeout(function () {
                        var tab = _this.data.tab;
                        var logList = tracking[tab];
                        if (search) {
                            if (tab === TAB_DEBUG.CONSOLE) {
                                logList = logList.filter(function (log) {
                                    return log.message.includes(search);
                                });
                            }
                            else {
                                logList = logList.filter(function (log) {
                                    return log.general.url.includes(search);
                                });
                            }
                        }
                        _this.setData({ logList: logList, search: search });
                    }, 300);
                };
                return [2 /*return*/];
            });
        });
    },
    deriveDataFromProps: function (nextProps) {
        var type = nextProps.type, env = nextProps.env, _a = nextProps.userEmail, userEmail = _a === void 0 ? "" : _a;
        if (env === ENV.PROD &&
            !checkEmailInWhiteList(userEmail, logger.whitelist)) {
            this.setData({ isShow: false });
            return;
        }
        this.setData({ isShow: true });
        if (type !== this.props.type)
            this.updateSetting({ type: type });
    },
    methods: {
        updateNetworkFilter: function () {
            var _filters = tracking[TAB_DEBUG.NETWORK].reduce(function (_filters, request) {
                var error = (request.resHeaders &&
                    request.resHeaders["http-status-code"] >= 400) ||
                    false;
                if (!error)
                    _filters[1].push(request);
                else
                    _filters[2].push(request);
                _filters[0].push(request);
                return _filters;
            }, [[], [], []]);
            var networkFilter = FILTER_TYPE.map(function (filter, index) {
                filter.logs = _filters[index];
                return filter;
            });
            this.setData({ networkFilter: networkFilter, activeFilter: FILTER_TYPE[0].key });
        },
        onOpenBottomSheet: function () {
            var tab = this.data.tab;
            if (tab === TAB_DEBUG.SETTING) {
                this.setData({ isShowLog: true });
                return;
            }
            if (tab === TAB_DEBUG.NETWORK)
                this.updateNetworkFilter();
            this.setData({
                logList: tracking[this.data.tab],
                isShowLog: true,
                search: "",
            });
        },
        onCloseBottomSheet: function () {
            this.setData({ isShowLog: false });
        },
        onClearLog: function () {
            tracking[this.data.tab].splice(0, tracking[this.data.tab].length);
            this.setData({ logList: tracking[this.data.tab] });
        },
        onChangeTap: function (event) {
            var tab = event.target.dataset.tab;
            if (tab === TAB_DEBUG.SETTING) {
                this.setData({ tab: tab });
                return;
            }
            if (tab === TAB_DEBUG.NETWORK)
                this.updateNetworkFilter();
            this.setData({ tab: tab, logList: tracking[tab], search: "" });
        },
        onChangeSetting: function (event) {
            var _a;
            var active = event.detail.value ? "on" : "off";
            var index = event.target.dataset.index;
            var settingOption = this.data.settingOptions[index];
            var option = (_a = {},
                _a[settingOption.field] = settingOption.values[active].value,
                _a);
            this.updateSetting(option);
        },
        updateSetting: function (options) {
            var settingOptions = this.data.settingOptions;
            var _a = Object.keys(options).reduce(function (_options, option) {
                var indexSetting = settingOptions.findIndex(function (setting) { return setting.field === option; });
                if (indexSetting < 0)
                    return;
                var setting = settingOptions[indexSetting];
                if (setting.isFieldInConfig) {
                    _options[0][option] = options[option];
                }
                else {
                    _options[1][option] = options[option];
                }
                settingOptions[indexSetting].activeValue =
                    settingOptions[indexSetting].values.on.value === options[option]
                        ? "on"
                        : "off";
                return _options;
            }, [{}, {}]), configOptions = _a[0], pageOptions = _a[1];
            logger.setConfig(configOptions);
            this.setData(__assign(__assign({}, pageOptions), { settingOptions: settingOptions }));
            if (options.type)
                this.updateView(options.type);
        },
        updateView: function (type) {
            var _this = this;
            if (type === TYPE_VIEW.SHAKE) {
                var tab_1 = this.data.tab;
                my.watchShake({
                    success: function () {
                        _this.setData({
                            isShowLog: type === TYPE_VIEW.SHAKE,
                            tab: tab_1 === TAB_DEBUG.SETTING ? TAB_DEBUG.CONSOLE : tab_1,
                        });
                    },
                });
            }
        },
        onChangeFilter: function (event) {
            var type = event.target.dataset.type;
            var networkFilter = this.data.networkFilter;
            var newIndex = networkFilter.findIndex(function (filter) { return filter.key === type; });
            this.setData({
                logList: networkFilter[newIndex].logs,
                activeFilter: type,
            });
        },
        onOpenDetail: function (_a) {
            var log = _a.log, request = _a.request;
            if (log)
                this.setData({ isShowLogBottomSheet: true, activeLog: log });
            if (request)
                this.setData({
                    isShowRequestBottomSheet: true,
                    activeRequest: request,
                });
            this.onCloseBottomSheet();
        },
        onCloseLogDetail: function () {
            this.setData({
                isShowLogBottomSheet: false,
                isShowRequestBottomSheet: false,
            });
            this.onOpenBottomSheet();
        },
        onCopy: function (event) {
            my.setClipboard({ text: event.target.dataset.text });
        },
    },
});
