var PATTERN_EMAIL = /^[\w-\\.]+@([\w-]+\.)+[\w-]{2,4}$/;
var PATTERN_EMAIL_DOMAIN = /^@([\w-]+\.)+[\w-]{2,4}$/;
export var checkEmailInWhiteList = function (email, patterns) {
    return (patterns.filter(function (pattern) {
        if (pattern.match(PATTERN_EMAIL_DOMAIN)) {
            // check domain
            var regex = new RegExp("^[\\w-\\.]+(".concat(pattern, ")"));
            return email.match(regex);
        }
        else if (pattern.match(PATTERN_EMAIL)) {
            // check full email
            return email === pattern;
        }
        else if (pattern === '*') {
            return true;
        }
        else {
            var regex = new RegExp(pattern);
            return email.match(regex);
        }
    }).length > 0);
};
